/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables.records;


import com.flamesgroup.storage.jooq.tables.Registry;

import java.util.Date;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record4;
import org.jooq.Row4;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class RegistryRecord extends UpdatableRecordImpl<RegistryRecord> implements Record4<Long, String, String, Date> {

	private static final long serialVersionUID = -1502512039;

	/**
	 * Setter for <code>public.registry.id</code>.
	 */
	public RegistryRecord setId(Long value) {
		setValue(0, value);
		return this;
	}

	/**
	 * Getter for <code>public.registry.id</code>.
	 */
	public Long getId() {
		return (Long) getValue(0);
	}

	/**
	 * Setter for <code>public.registry.path</code>.
	 */
	public RegistryRecord setPath(String value) {
		setValue(1, value);
		return this;
	}

	/**
	 * Getter for <code>public.registry.path</code>.
	 */
	public String getPath() {
		return (String) getValue(1);
	}

	/**
	 * Setter for <code>public.registry.value</code>.
	 */
	public RegistryRecord setValue(String value) {
		setValue(2, value);
		return this;
	}

	/**
	 * Getter for <code>public.registry.value</code>.
	 */
	public String getValue() {
		return (String) getValue(2);
	}

	/**
	 * Setter for <code>public.registry.updating_time</code>.
	 */
	public RegistryRecord setUpdatingTime(Date value) {
		setValue(3, value);
		return this;
	}

	/**
	 * Getter for <code>public.registry.updating_time</code>.
	 */
	public Date getUpdatingTime() {
		return (Date) getValue(3);
	}

	// -------------------------------------------------------------------------
	// Primary key information
	// -------------------------------------------------------------------------

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Record1<Long> key() {
		return (Record1) super.key();
	}

	// -------------------------------------------------------------------------
	// Record4 type implementation
	// -------------------------------------------------------------------------

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Row4<Long, String, String, Date> fieldsRow() {
		return (Row4) super.fieldsRow();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Row4<Long, String, String, Date> valuesRow() {
		return (Row4) super.valuesRow();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Long> field1() {
		return Registry.REGISTRY.ID;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<String> field2() {
		return Registry.REGISTRY.PATH;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<String> field3() {
		return Registry.REGISTRY.VALUE;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Date> field4() {
		return Registry.REGISTRY.UPDATING_TIME;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Long value1() {
		return getId();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String value2() {
		return getPath();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String value3() {
		return getValue();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Date value4() {
		return getUpdatingTime();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public RegistryRecord value1(Long value) {
		setId(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public RegistryRecord value2(String value) {
		setPath(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public RegistryRecord value3(String value) {
		setValue(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public RegistryRecord value4(Date value) {
		setUpdatingTime(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public RegistryRecord values(Long value1, String value2, String value3, Date value4) {
		value1(value1);
		value2(value2);
		value3(value3);
		value4(value4);
		return this;
	}

	// -------------------------------------------------------------------------
	// Constructors
	// -------------------------------------------------------------------------

	/**
	 * Create a detached RegistryRecord
	 */
	public RegistryRecord() {
		super(Registry.REGISTRY);
	}

	/**
	 * Create a detached, initialised RegistryRecord
	 */
	public RegistryRecord(Long id, String path, String value, Date updatingTime) {
		super(Registry.REGISTRY);

		setValue(0, id);
		setValue(1, path);
		setValue(2, value);
		setValue(3, updatingTime);
	}
}
